<?php
require_once(dirname(__FILE__)."/../DBConfiguration.php");

/**
 * @author Mat <mat_sf@users.sourceforge.net>
 */
class DBReader {
    private $begin;
    private $end;
    private $pathsArray;

    function __construct($beginTimestamp, $endTimestamp) {
        $this->begin = $beginTimestamp;
        $this->end = $endTimestamp;
    }

    public function load() {
        $beginYear = date("y",$this->begin);
        $beginMonth = date("m",$this->begin);

        $endYear = date("y",$this->end);
        $endMonth = date("m",$this->end);

        if ($beginYear > $endYear) {
            throw new Exception("XXX"); //FIXME
        }

        if ($beginYear == $endYear && $beginMonth > $endMonth) {
            throw new Exception("XXX"); //FIXME
        }

        //------------------------------------------------------------------------------------------

        //loop by years
        for($beginYearLoop=$beginYear; $beginYearLoop<=$endYear; $beginYearLoop++) {
            if ($beginYearLoop==$beginYear) {
                $beginMonthLoop=$beginMonth;
                $endMonthLoop=12;
            } elseif ($beginYearLoop==$endYear) {
                $beginMonthLoop=1;
                $endMonthLoop=$endMonth;
            } else {
                $beginMonthLoop=1;
                $endMonthLoop=12;
            }

            if (strlen($beginYearLoop) == 1) {
                $beginYearLoopTmp = "0".$beginYearLoop;
            } else {
                $beginYearLoopTmp = $beginYearLoop;
            }
            if (strlen($beginYearLoop) > 2) {
                $beginYearLoopTmp = substr($beginYearLoop,-2,2);
            }

            //loop by months
            for($i=$beginMonthLoop;$i<=$endMonthLoop;$i++) {
                if ($beginYear==$endYear && $i>$endMonth) {
                    continue;
                }

                if (strlen($i) == 1) {
                    $iTmp = "0".$i;
                } else {
                    $iTmp = $i;
                }

                $path = DBConfiguration::getPath().$beginYearLoopTmp."/".$iTmp.".csv";
                $this->pathsArray[] = $path;
            }
        }

        $csvFileIterator = new CSVFileIterator($this->pathsArray);

        return new DBIterator($csvFileIterator, $this->begin, $this->end);
    }
}
?>
